Imports System.Drawing.Printing

Public Class frmPrintStart

    Private m_Print As Boolean = False
    Private m_Preview As Boolean = False
    Private m_Cancel As Boolean = True
    Private m_Printername As String = Nothing
    Private m_Copies As Int32 = 1

    ''' <summary>
    ''' Bezeichnung des Formulars
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property FormularName() As String
        Get
            FormularName = Me.Text
        End Get
        Set(ByVal value As String)
            Me.Text = value
        End Set
    End Property

    ''' <summary>
    ''' liefert ob Print angewhlt wurde
    ''' </summary>
    Public ReadOnly Property Print() As Boolean
        Get
            Print = m_Print
        End Get
    End Property

    ''' <summary>
    ''' liefert ob Preview angewhlt wurde
    ''' </summary>
    Public ReadOnly Property Preview() As Boolean
        Get
            Preview = m_Preview
        End Get
    End Property

    ''' <summary>
    ''' liefert ob Cancel angewhlt wurde
    ''' </summary>
    Public ReadOnly Property Cancel() As Boolean
        Get
            Cancel = m_Cancel
        End Get
    End Property

    ''' <summary>
    ''' liefert den Printer(namen) oder legt ihn fest
    ''' </summary>
    Public Property PrinterName() As String
        Get
            PrinterName = cboPrinters.Text
        End Get
        Set(ByVal value As String)
            m_Printername = value
        End Set
    End Property

    ''' <summary>
    ''' ruft ab ob ein Standarddrucker ausgewhlt wurde
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property PrinterDefaultSet() As Boolean
        Get
            PrinterDefaultSet = chkDefault.Checked
        End Get
    End Property

    ''' <summary>
    ''' liefert die Anzahl der Copies oder legt sie fest, default = 1
    ''' </summary>
    Public Property Copies() As Int32
        Get
            Copies = Convert.ToInt32(cboCopies.Text)
        End Get
        Set(ByVal value As Int32)
            m_Copies = value
        End Set
    End Property

    ''' <summary>
    ''' ldt die Combos
    ''' </summary>
    Private Sub frmPrintStart_Load(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles MyBase.Load

        FillCombos()
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object,
        ByVal e As System.EventArgs) Handles btnCancel.Click

        m_Cancel = True
        Me.Close()
    End Sub

    Private Sub btnPreview_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles btnPreview.Click

        m_Preview = True
        m_Cancel = False
        Me.Close()
    End Sub

    Private Sub btnPrint_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles btnPrint.Click

        m_Print = True
        m_Cancel = False
        Me.Close()
    End Sub

    ''' <summary>
    ''' stellt die Comboboxen auf Default Werte
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub FillCombos()

        Dim Ps As New PrinterSettings
        For Each PrName As String In PrinterSettings.InstalledPrinters
            cboPrinters.Items.Add(PrName)
            If PrName = Ps.PrinterName Then
                cboPrinters.SelectedIndex = cboPrinters.Items.Count - 1
            End If
        Next

        If m_Printername <> Nothing Then
            For i As Int32 = 0 To cboPrinters.Items.Count - 1
                If m_Printername.ToLower =
                        cboPrinters.Items.Item(i).ToString.ToLower Then
                    cboPrinters.SelectedIndex = i
                    Exit For
                End If
            Next
        End If

        For i As Int32 = 1 To 9
            cboCopies.Items.Add(i.ToString)
        Next
        cboCopies.SelectedIndex = 0

        If (m_Copies <= 9) And (m_Copies > 0) Then
            cboCopies.SelectedIndex = m_Copies - 1
        End If
    End Sub
End Class
